#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include<stdlib.h>

typedef struct{
    char ime[21];
    int kolicina;
} potreba;

typedef struct{
    char ime[21];
    double cijena;
} artikl;


/// funkcija koja pretvara string u broj
int to_num(char *str,int kraj){
    int i,sum=0,desetica=1;
    for(i=kraj;i>=0;i--){
        int n=str[i]-'0';
        sum += desetica*n;
        desetica *= 10;
    }
    return sum;
}

potreba *izvuci(char *str, int *n){
    int i=0,duljina=1;
    potreba *x=NULL;


    while(str[i]!='\0'){
        int j,k,sum,l;
        x=realloc(x,sizeof(potreba)*duljina);

        for(j=0;isdigit(str[i+j])>0;j++); /// trazenje gdje zavrsava broj, a pocinje ime artikla
        sum=to_num(str+i,j-1);
        x[duljina-1].kolicina=sum;


        for(k=0;str[i+j+k]!=';';k++){
                x[duljina-1].ime[k]=str[i+j+k]; /// kopiranje imena artikla sve do znaka ';'
        }
        x[duljina-1].ime[k]='\0';           /// dodavanje '\0' na kraju

        duljina++;
        i += j+k+1;

    }

    if(i==0) *n=0;  /// imamo prazan string str
    else *n=duljina-1;

    return x;
}


double iznosRacuna(char *str, artikl *sviArtikli,int n){
    int duljina,i,j;
    double racun=0;
    potreba *x;

    x=izvuci(str,&duljina);
    for(i=0;i<duljina;i++){
        for(j=0;j<n;j++){
            if(strcmp(x[i].ime,sviArtikli[j].ime)==0){
                racun+=sviArtikli[j].cijena*x[i].kolicina;
                break;
            }
        }
    }
    free(x);
    return racun;
}

int main(){
    char *str="10jaje;2mlijeko;4kruh;";
    int n,i;
    potreba *x;
    artikl *sviArtikli;

   /// test za funkciju izvuci
   printf("string s namirnicama=%s\n",str);
    x=izvuci(str,&n);
    for(i=0;i<n;i++){
        printf("%d:ime namirnice=%s, \t kolicina namirnice=%d\n",i,x[i].ime,x[i].kolicina);
    }
    free(x);

    /// test za funkciju iznosRacuna
    sviArtikli=malloc(sizeof(artikl)*4);  /// prvo alokacija za 4 artikala
    strcpy(sviArtikli[0].ime,"mlijeko");
    strcpy(sviArtikli[1].ime,"maslac");
    strcpy(sviArtikli[2].ime,"jaje");
    strcpy(sviArtikli[3].ime,"kruh");
    sviArtikli[0].cijena=6.99;            /// realne cijene
    sviArtikli[1].cijena=15.99;
    sviArtikli[2].cijena=0.99;
    sviArtikli[3].cijena=10.50;

    printf("iznosRacuna=%lg\n",iznosRacuna(str,sviArtikli,4));


    return 0;
}
